'use strict';
import {dissolveUrl} from '../../../src/utilities/dissolveUrl';

test.each([
    ['http://localhost:3000', ['iconUrl', 'screenshots'],
        {
            iconUrl: '/resources/icon.svg',
            screenshots: [
                '/resources/screenshots/screenshot1.png',
                '/resources/screenshots/screenshot2.png'
            ]
        },
        {
            iconUrl: 'http://localhost:3000/resources/icon.svg',
            screenshots: [
                'http://localhost:3000/resources/screenshots/screenshot1.png',
                'http://localhost:3000/resources/screenshots/screenshot2.png'
            ]
        }
    ],
    ['http://localhost:3000', ['icon.url'],
        {
            icon: {name: 'i1', url: '/resources/icon.svg'}
        },
        {
            icon: {name: 'i1', url: 'http://localhost:3000/resources/icon.svg'}
        }
    ],
    ['http://localhost:3000', ['screenshots.url'],
        {
            screenshots: [
                {name: 's1', url: '/resources/screenshots/screenshot1.png'},
                {name: 's2', url: '/resources/screenshots/screenshot2.png'}
            ]
        },
        {
            screenshots: [
                {name: 's1', url: 'http://localhost:3000/resources/screenshots/screenshot1.png'},
                {name: 's2', url: 'http://localhost:3000/resources/screenshots/screenshot2.png'}
            ]
        }
    ]
])(
    'dissolveUrl with baseUrl %s and properties %j = %j',
    (baseUrl, properties, object, expected) => {
        expect(dissolveUrl(baseUrl, properties, object)).toEqual(expected);
    }
);
