'use strict';
import {localize} from '../../../src/utilities/localize';

const localizeData = {
    shortName: 'test',
    name: {
        de: 'Testserver',
        en: 'test server'
    },
    description: {
        de: 'Testbeschreibung',
        en: 'test description'
    }
};

test.each([
    ['de', localizeData, {shortName: 'test', name: 'Testserver', description: 'Testbeschreibung'}],
    ['en', localizeData, {shortName: 'test', name: 'test server', description: 'test description'}]
])(
    'localize %s and object %j = %j',
    (locale, object, expected) => {
        expect(localize(locale, object)).toEqual(expected);
    }
);
