import {sort} from '../../../src/utilities/sort';

test.each([
    [
        ['test', 'test1', 'test-2', 'test-1', 'test2', 'test-a', 'test-z', 'test-b', 'test_a', 'test_b'],
        undefined,
        true,
        ['test', 'test-1', 'test-2', 'test-a', 'test-b', 'test-z', 'test1', 'test2', 'test_a', 'test_b']
    ],
    [
        [{property: 'test1'}, {property: 'test3'}, {property: 'test2'}],
        'property',
        true,
        [{property: 'test1'}, {property: 'test2'}, {property: 'test3'}]
    ],
    [
        [{value: 2, property: {sub: 'test1'}}, {value: 1, property: {sub: 'test3'}}, {
            value: 1,
            property: {sub: 'test2'}
        }],
        ['value', 'property.sub'],
        ['asc', 'asc'],
        [{value: 1, property: {sub: 'test2'}}, {value: 1, property: {sub: 'test3'}}, {
            value: 2,
            property: {sub: 'test1'}
        }]
    ],
    [
        [{property: 1}, {property: 3}, {property: 2}],
        'property',
        true,
        [{property: 1}, {property: 2}, {property: 3}]
    ],
    [
        [{property: 1}, {property: 3}, {property: 2}],
        'property',
        false,
        [{property: 3}, {property: 2}, {property: 1}]
    ]
])(
    'sort array %j with properties %j and ascending %j = %j',
    (array, properties, ascending: any, expected) => {
        expect(sort(array, properties, ascending)).toEqual(expected);
    }
);
