import * as filter from '../../../src/validators/arrayValidators';
import items from '../../data/items.json';

const array = ['test1', 'test2', 'test3'];

test.each([
    ['arraySizeValidator', null, 0, false],
    ['arraySizeValidator', [], 0, true],
    ['arraySizeValidator', items, 50, true],
    ['arraySizeValidator', items, 1, false],
    ['arrayElementTypeValidator', array, 'string', true],
    ['arrayElementTypeValidator', array, 'number', false],
    ['arrayElementTypeValidator', [1, 2, 3], 'number', true],
    ['arrayElementTypeValidator', [1, 2, 3], 'object', false],
    ['arrayElementTypeValidator', [{prop1: 'test1'}, {prop2: 'test2'}], 'object', true],
    ['arrayElementTypeValidator', [{prop1: 'test1'}, {prop2: 'test2'}], 'boolean', false],
    ['arrayElementTypeValidator', [true, false, false], 'boolean', true],
    ['arrayIncludesCaseInsensitiveValidator', array, ['test'], true],
    ['arrayIncludesCaseInsensitiveValidator', array, ['Test1', 'Test2', 'Test3'], true],
    ['arrayIncludesCaseInsensitiveValidator', array, ['test1', 'test2', 'test3'], true],
    ['arrayIncludesCaseInsensitiveValidator', array, ['fail'], false],
    ['arrayIncludesCaseSensitiveValidator', array, ['test'], true],
    ['arrayIncludesCaseSensitiveValidator', array, ['Test1', 'Test2', 'Test3'], false],
    ['arrayIncludesCaseSensitiveValidator', array, ['test1', 'test2', 'test3'], true],
    ['arrayIncludesCaseSensitiveValidator', array, ['fail'], false]
])(
    '%s for value %s and key %j = %j',
    (validator, value, comparator, expected) => {
        expect((filter as any)[validator](value, comparator)).toBe(expected);
    }
);
