import * as filter from '../../../src/validators/numberValidators';

test.each([
    ['multipleOfValidator', 2, 2, true],
    ['multipleOfValidator', 10, 5, true],
    ['multipleOfValidator', 9, 3, true],
    ['multipleOfValidator', 27, 9, true],
    ['multipleOfValidator', 5, 3, false],
    ['minimumValidator', 10, 1, true],
    ['minimumValidator', 10, 10, true],
    ['minimumValidator', 10, 11, false],
    ['exclusiveMinimumValidator', 10, 1, true],
    ['exclusiveMinimumValidator', 10, 10, false],
    ['exclusiveMinimumValidator', 10, 11, false],
    ['maximumValidator', 1, 10, true],
    ['maximumValidator', 10, 10, true],
    ['maximumValidator', 11, 10, false],
    ['exclusiveMaximumValidator', 1, 10, true],
    ['exclusiveMaximumValidator', 10, 10, false],
    ['exclusiveMaximumValidator', 11, 10, false]
])(
    '%s for value %s and key %j = %j',
    (validator, value, comparator, expected) => {
        expect((filter as any)[validator](value, comparator)).toBe(expected);
    }
);
